Index: src/Actions/FragmentationAction/FragmentationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/FragmentationAction/FragmentationAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * FragmentationAction.cpp
@@ -6,12 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/FragmentationAction/FragmentationAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "bondgraph.hpp"
 #include "config.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
@@ -24,57 +34,29 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/FragmentationAction/FragmentationAction.hpp"
 
-const char FragmentationFragmentationAction::NAME[] = "fragment-mol";
-
-FragmentationFragmentationAction::FragmentationFragmentationAction() :
-  Action(NAME)
-{}
-
-FragmentationFragmentationAction::~FragmentationFragmentationAction()
-{}
-
-void FragmentationFragmentation(std::string &path, double distance, int order) {
-  ValueStorage::getInstance().setCurrentValue(FragmentationFragmentationAction::NAME, path);
-  ValueStorage::getInstance().setCurrentValue("distance", distance);
-  ValueStorage::getInstance().setCurrentValue("order", order);
-  ActionRegistry::getInstance().getActionByName(FragmentationFragmentationAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* FragmentationFragmentationAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryDouble("distance", ValueStorage::getInstance().getDescription("distance"));
-  dialog->queryInt("order", ValueStorage::getInstance().getDescription("order"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "FragmentationAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr FragmentationFragmentationAction::performCall() {
   clock_t start,end;
   molecule *mol = NULL;
-  double distance = -1.;
-  int order = 0;
-  std::string path;
   config *configuration = World::getInstance().getConfig();
   int ExitFlag = 0;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, path);
-  ValueStorage::getInstance().queryCurrentValue("distance", distance);
-  ValueStorage::getInstance().queryCurrentValue("order", order);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
     mol = iter->second;
     ASSERT(mol != NULL, "No molecule has been picked for fragmentation.");
-    DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with bond distance " << distance << " angstroem, order of " << order << "." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with bond distance " << params.distance << " angstroem, order of " << params.order << "." << endl);
     DoLog(0) && (Log() << Verbose(0) << "Creating connection matrix..." << endl);
     start = clock();
-    mol->CreateAdjacencyList(distance, configuration->GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
+    mol->CreateAdjacencyList(params.distance, configuration->GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
     DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl);
     if (mol->hasBondStructure()) {
-      ExitFlag = mol->FragmentMolecule(order, path);
+      ExitFlag = mol->FragmentMolecule(params.order, params.path);
     }
     World::getInstance().setExitFlag(ExitFlag);
@@ -104,2 +86,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/FragmentationAction/FragmentationAction.def
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/FragmentationAction/FragmentationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * FragmentationAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string) (double) (int)
+#define paramtokens (FragmentationFragmentationAction::NAME) ("distance") ("order")
+#define paramreferences (path) (distance) (order)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Fragmentation
+#define ACTIONNAME Fragmentation
+#define TOKEN "fragment-mol"
+
Index: src/Actions/FragmentationAction/FragmentationAction.hpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/FragmentationAction/FragmentationAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void FragmentationFragmentation(std::string &path, double distance, int order);
-
-class FragmentationFragmentationAction : public Action {
-  friend void FragmentationFragmentation(std::string &path, double distance, int order);
-
-public:
-  FragmentationFragmentationAction();
-  virtual ~FragmentationFragmentationAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "FragmentationAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* FRAGMENTATIONACTION_HPP_ */
Index: src/Actions/FragmentationAction/SubgraphDissectionAction.cpp
===================================================================
--- src/Actions/FragmentationAction/SubgraphDissectionAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/FragmentationAction/SubgraphDissectionAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SubgraphDissectionAction.cpp
@@ -6,13 +13,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+
 #include "atom.hpp"
+#include "bond.hpp"
+#include "bondgraph.hpp"
 #include "config.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "molecule.hpp"
-#include "Descriptors/MoleculeDescriptor.hpp"
 #include "stackclass.hpp"
 #include "World.hpp"
@@ -21,60 +36,179 @@
 #include <string>
 
+typedef std::map< moleculeId_t, std::vector<atomId_t> > MolAtomList;
+typedef std::map< atomId_t, atomId_t > AtomAtomList;
+
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-
-const char FragmentationSubgraphDissectionAction::NAME[] = "subgraph-dissect";
-
-FragmentationSubgraphDissectionAction::FragmentationSubgraphDissectionAction() :
-  Action(NAME)
-{}
-
-FragmentationSubgraphDissectionAction::~FragmentationSubgraphDissectionAction()
-{}
-
-void FragmentationSubgraphDissection() {
-  ActionRegistry::getInstance().getActionByName(FragmentationSubgraphDissectionAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* FragmentationSubgraphDissectionAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-
+#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
+
+// and construct the stuff
+#include "SubgraphDissectionAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr FragmentationSubgraphDissectionAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
   DoLog(1) && (Log() << Verbose(1) << "Dissecting molecular system into a set of disconnected subgraphs ... " << endl);
-  // @TODO rather do the dissection afterwards
+
+  // first create stuff for undo state
+  MolAtomList moleculelist;
+  vector<molecule *> allmolecules = World::getInstance().getAllMolecules();
+  for (vector<molecule *>::const_iterator moliter = allmolecules.begin(); moliter != allmolecules.end(); ++moliter) {
+    std::vector<atomId_t> atomlist;
+    atomlist.resize((*moliter)->size());
+    for (molecule::const_iterator atomiter = (*moliter)->begin(); atomiter != (*moliter)->end(); ++atomiter) {
+      atomlist.push_back((*atomiter)->getId());
+    }
+    moleculelist.insert( std::pair< moleculeId_t, std::vector<atomId_t> > ((*moliter)->getId(), atomlist));
+  }
+  FragmentationSubgraphDissectionState *UndoState = new FragmentationSubgraphDissectionState(moleculelist, params);
+
+  // 0a. remove all present molecules
   MoleculeListClass *molecules = World::getInstance().getMolecules();
-  molecules->DissectMoleculeIntoConnectedSubgraphs(World::getInstance().getPeriode(), World::getInstance().getConfig());
-  return Action::success;
+  for (vector<molecule *>::iterator MolRunner = allmolecules.begin(); MolRunner != allmolecules.end(); ++MolRunner) {
+    molecules->erase(*MolRunner);
+    World::getInstance().destroyMolecule(*MolRunner);
+  }
+
+  // 0b. remove all bonds and construct a molecule with all atoms
+  molecule *mol = World::getInstance().createMolecule();
+  int BondCount = 0;
+  {
+    vector <atom *> allatoms = World::getInstance().getAllAtoms();
+    for(vector<atom *>::iterator AtomRunner = allatoms.begin(); AtomRunner != allatoms.end(); ++AtomRunner) {
+      BondCount += (*AtomRunner)->ListOfBonds.size();
+//      for(BondList::iterator BondRunner = (*AtomRunner)->ListOfBonds.begin(); !(*AtomRunner)->ListOfBonds.empty(); BondRunner = (*AtomRunner)->ListOfBonds.begin())
+//        delete(*BondRunner);
+      mol->AddAtom(*AtomRunner);
+    }
+  }
+
+  // 1. create the bond structure of the single molecule
+  if (BondCount == 0) {
+    config * const configuration = World::getInstance().getConfig();
+    if ((configuration->BG != NULL)) {
+      if (!configuration->BG->ConstructBondGraph(mol)) {
+        World::getInstance().destroyMolecule(mol);
+        DoeLog(1) && (eLog()<< Verbose(1) << "There are no bonds." << endl);
+        return Action::failure;
+      }
+    } else {
+      DoeLog(1) && (eLog()<< Verbose(1) << "There is no BondGraph class present to create bonds." << endl);
+      return Action::failure;
+    }
+  }
+
+  // 2. scan for connected subgraphs
+  MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
+  class StackClass<bond *> *BackEdgeStack = NULL;
+  Subgraphs = mol->DepthFirstSearchAnalysis(BackEdgeStack);
+  delete(BackEdgeStack);
+  if ((Subgraphs == NULL) || (Subgraphs->next == NULL)) {
+    //World::getInstance().destroyMolecule(mol);
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no atoms." << endl);
+    return Action::failure;
+  }
+
+  //int FragmentCounter = Subgraphs->next->Count();
+
+  // TODO: When DepthFirstSearchAnalysis does not use AddCopyAtom() anymore, we don't need to delete all original atoms
+  {
+    {
+      atom **ListOfAtoms = NULL;
+      // 3a. re-create bond structure and insert molecules into general MoleculeListClass
+      MoleculeLeafClass *MoleculeWalker = Subgraphs->next;
+      while (MoleculeWalker->next != NULL) {
+        ListOfAtoms = NULL;
+        MoleculeWalker->FillBondStructureFromReference(mol, ListOfAtoms, true);  // we want to keep the created ListOfLocalAtoms
+        molecules->insert(MoleculeWalker->Leaf);
+        MoleculeWalker = MoleculeWalker->next;
+      }
+      molecules->insert(MoleculeWalker->Leaf);
+      ListOfAtoms = NULL;
+      MoleculeWalker->FillBondStructureFromReference(mol, ListOfAtoms, true);  // we want to keep the created ListOfLocalAtoms
+    }
+
+    // 3b. store map from new to old ids for 3d
+    vector <atom *> allatoms = World::getInstance().getAllAtoms();
+    AtomAtomList newtooldlist;
+    for(vector<atom *>::iterator AtomRunner = allatoms.begin(); AtomRunner != allatoms.end(); ++AtomRunner)
+      if ((*AtomRunner)->father != (*AtomRunner))
+        newtooldlist.insert( std::pair<atomId_t, atomId_t> ((*AtomRunner)->getId(),(*AtomRunner)->father->getId()) );
+
+    {
+      // 3c. destroy the original molecule
+      for (molecule::iterator AtomRunner = mol->begin(); !mol->empty(); AtomRunner = mol->begin())
+        World::getInstance().destroyAtom(*AtomRunner);
+      World::getInstance().destroyMolecule(mol);
+    }
+
+    {
+      // 3d. convert to old Ids and correct fathers (AddCopyAtom sets father to original atom, which has been destroyed).
+      vector <atom *> allatoms = World::getInstance().getAllAtoms();
+      for(vector<atom *>::iterator AtomRunner = allatoms.begin(); AtomRunner != allatoms.end(); ++AtomRunner) {
+        World::getInstance().changeAtomId((*AtomRunner)->getId(), newtooldlist[(*AtomRunner)->getId()]);
+        (*AtomRunner)->father = *AtomRunner;
+      }
+    }
+  }
+
+  // 4. free Leafs
+  MoleculeLeafClass *MolecularWalker = Subgraphs;
+  while (MolecularWalker->next != NULL) {
+    MolecularWalker->Leaf = NULL;
+    MolecularWalker = MolecularWalker->next;
+    delete(MolecularWalker->previous);
+  }
+  MolecularWalker->Leaf = NULL;
+  delete(MolecularWalker);
+  DoLog(1) && (Log() << Verbose(1) << "I scanned " << molecules->ListOfMolecules.size() << " molecules." << endl);
+
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr FragmentationSubgraphDissectionAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
-
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  FragmentationSubgraphDissectionState *state = assert_cast<FragmentationSubgraphDissectionState*>(_state.get());
+
+  {
+    // remove all present molecules
+    MoleculeListClass *molecules = World::getInstance().getMolecules();
+    vector<molecule *> allmolecules = World::getInstance().getAllMolecules();
+    for (vector<molecule *>::iterator MolRunner = allmolecules.begin(); MolRunner != allmolecules.end(); ++MolRunner) {
+      molecules->erase(*MolRunner);
+      World::getInstance().destroyMolecule(*MolRunner);
+    }
+  }
+
+  {
+    // construct the old state
+    MoleculeListClass *molecules = World::getInstance().getMolecules();
+    molecule *mol = NULL;
+    for (MolAtomList::const_iterator iter = state->moleculelist.begin(); iter != state->moleculelist.end(); ++iter) {
+      mol = World::getInstance().createMolecule();
+      if (mol->getId() != (*iter).first)
+        World::getInstance().changeMoleculeId(mol->getId(), (*iter).first);
+      for (std::vector<atomId_t>::const_iterator atomiter = (*iter).second.begin(); atomiter != (*iter).second.end(); ++atomiter) {
+        atom *Walker = World::getInstance().getAtom(AtomById(*atomiter));
+        mol->AddAtom(Walker);
+      }
+      molecules->insert(mol);
+    }
+  }
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr FragmentationSubgraphDissectionAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return performCall();
 }
 
 bool FragmentationSubgraphDissectionAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool FragmentationSubgraphDissectionAction::shouldUndo() {
-  return false;
+  return true;
 }
 
@@ -82,2 +216,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/FragmentationAction/SubgraphDissectionAction.def
===================================================================
--- src/Actions/FragmentationAction/SubgraphDissectionAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/FragmentationAction/SubgraphDissectionAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * SubgraphDissectionAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (MolAtomList)
+#define statereferences (moleculelist)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Fragmentation
+#define ACTIONNAME SubgraphDissection
+#define TOKEN "subgraph-dissect"
+
Index: src/Actions/FragmentationAction/SubgraphDissectionAction.hpp
===================================================================
--- src/Actions/FragmentationAction/SubgraphDissectionAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/FragmentationAction/SubgraphDissectionAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -7,30 +7,10 @@
 
 #ifndef SUBGRAPHDISSECTIONACTION_HPP_
-#define SUBGRAPHDISSECTIONACTION_HPP_f
+#define SUBGRAPHDISSECTIONACTION_HPP_
 
 #include "Actions/Action.hpp"
 
-void FragmentationSubgraphDissection();
-
-class FragmentationSubgraphDissectionAction : public Action {
-  friend void FragmentationSubgraphDissection();
-
-public:
-  FragmentationSubgraphDissectionAction();
-  virtual ~FragmentationSubgraphDissectionAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "SubgraphDissectionAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* SUBGRAPHDISSECTIONACTION_HPP_ */
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -50,30 +50,36 @@
   AtomAction/AddAction.cpp \
   AtomAction/ChangeElementAction.cpp \
-  AtomAction/RemoveAction.cpp
+  AtomAction/RemoveAction.cpp \
+  AtomAction/RotateAroundOriginByAngleAction.cpp \
+  AtomAction/TranslateAction.cpp
 ATOMACTIONHEADER = \
   AtomAction/AddAction.hpp \
   AtomAction/ChangeElementAction.hpp \
-  AtomAction/RemoveAction.cpp
+  AtomAction/RemoveAction.cpp \
+  AtomAction/RotateAroundOriginByAngleAction.hpp \
+  AtomAction/TranslateAction.hpp
 
 CMDACTIONSOURCE = \
-  CmdAction/BondLengthTableAction.cpp \
-  CmdAction/ElementDbAction.cpp \
-  CmdAction/FastParsingAction.cpp \
-  CmdAction/HelpAction.cpp \
-  CmdAction/VerboseAction.cpp \
-  CmdAction/VersionAction.cpp
+  CommandAction/BondLengthTableAction.cpp \
+  CommandAction/ElementDbAction.cpp \
+  CommandAction/FastParsingAction.cpp \
+  CommandAction/HelpAction.cpp \
+  CommandAction/VerboseAction.cpp \
+  CommandAction/VersionAction.cpp
 CMDACTIONHEADER = \
-  CmdAction/BondLengthTableAction.hpp \
-  CmdAction/ElementDbAction.hpp \
-  CmdAction/FastParsingAction.hpp \
-  CmdAction/HelpAction.hpp \
-  CmdAction/VerboseAction.hpp \
-  CmdAction/VersionAction.hpp
+  CommandAction/BondLengthTableAction.hpp \
+  CommandAction/ElementDbAction.hpp \
+  CommandAction/FastParsingAction.hpp \
+  CommandAction/HelpAction.hpp \
+  CommandAction/VerboseAction.hpp \
+  CommandAction/VersionAction.hpp
 
 FRAGMENTATIONACTIONSOURCE = \
+  FragmentationAction/ConstructBondGraphAction.cpp \
   FragmentationAction/DepthFirstSearchAction.cpp \
   FragmentationAction/FragmentationAction.cpp \
   FragmentationAction/SubgraphDissectionAction.cpp               
 FRAGMENTATIONACTIONHEADER = \
+  FragmentationAction/ConstructBondGraphAction.hpp \
   FragmentationAction/DepthFirstSearchAction.hpp \
   FragmentationAction/FragmentationAction.hpp \
@@ -83,6 +89,8 @@
   MoleculeAction/BondFileAction.cpp \
   MoleculeAction/ChangeNameAction.cpp \
+  MoleculeAction/CopyAction.cpp \
   MoleculeAction/FillWithMoleculeAction.cpp \
   MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
+  MoleculeAction/RotateAroundSelfByAngleAction.cpp \
   MoleculeAction/RotateToPrincipalAxisSystemAction.cpp \
   MoleculeAction/SaveAdjacencyAction.cpp \
@@ -90,11 +98,12 @@
   MoleculeAction/SaveTemperatureAction.cpp \
   MoleculeAction/SuspendInWaterAction.cpp \
-  MoleculeAction/TranslateAction.cpp \
   MoleculeAction/VerletIntegrationAction.cpp
 MOLECULEACTIONHEADER = \
   MoleculeAction/BondFileAction.hpp \
   MoleculeAction/ChangeNameAction.hpp \
+  MoleculeAction/CopyAction.hpp \
   MoleculeAction/FillWithMoleculeAction.hpp \
   MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
+  MoleculeAction/RotateAroundSelfByAngleAction.hpp \
   MoleculeAction/RotateToPrincipalAxisSystemAction.hpp \
   MoleculeAction/SaveAdjacencyAction.hpp \
@@ -102,5 +111,4 @@
   MoleculeAction/SaveTemperatureAction.hpp \
   MoleculeAction/SuspendInWaterAction.hpp \
-  MoleculeAction/TranslateAction.hpp \
   MoleculeAction/VerletIntegrationAction.hpp
                  
@@ -114,20 +122,48 @@
 SELECTIONACTIONSOURCE = \
 	SelectionAction/AllAtomsAction.cpp \
+	SelectionAction/AllAtomsInsideCuboidAction.cpp \
+	SelectionAction/AllAtomsInsideSphereAction.cpp \
+	SelectionAction/AllAtomsOfMoleculeAction.cpp \
 	SelectionAction/AllMoleculesAction.cpp \
+	SelectionAction/AtomByElementAction.cpp \
 	SelectionAction/AtomByIdAction.cpp \
+	SelectionAction/ClearAllAtomsAction.cpp \
+	SelectionAction/ClearAllMoleculesAction.cpp \
+	SelectionAction/MoleculeByFormulaAction.cpp \
 	SelectionAction/MoleculeByIdAction.cpp \
+	SelectionAction/MoleculeOfAtomAction.cpp \
 	SelectionAction/NotAllAtomsAction.cpp \
+	SelectionAction/NotAllAtomsInsideCuboidAction.cpp \
+	SelectionAction/NotAllAtomsInsideSphereAction.cpp \
+	SelectionAction/NotAllAtomsOfMoleculeAction.cpp \
 	SelectionAction/NotAllMoleculesAction.cpp \
+	SelectionAction/NotAtomByElementAction.cpp \
 	SelectionAction/NotAtomByIdAction.cpp \
-	SelectionAction/NotMoleculeByIdAction.cpp
+	SelectionAction/NotMoleculeByFormulaAction.cpp \
+	SelectionAction/NotMoleculeByIdAction.cpp \
+	SelectionAction/NotMoleculeOfAtomAction.cpp
 SELECTIONACTIONHEADER = \
 	SelectionAction/AllAtomsAction.hpp \
+	SelectionAction/AllAtomsInsideCuboidAction.hpp \
+	SelectionAction/AllAtomsInsideSphereAction.hpp \
+	SelectionAction/AllAtomsOfMoleculeAction.hpp \
 	SelectionAction/AllMoleculesAction.hpp \
+	SelectionAction/AtomByElementAction.hpp \
 	SelectionAction/AtomByIdAction.hpp \
+	SelectionAction/ClearAllAtomsAction.hpp \
+	SelectionAction/ClearAllMoleculesAction.hpp \
+	SelectionAction/MoleculeByFormulaAction.hpp \
 	SelectionAction/MoleculeByIdAction.hpp \
+	SelectionAction/MoleculeOfAtomAction.hpp \
 	SelectionAction/NotAllAtomsAction.hpp \
+	SelectionAction/NotAllAtomsInsideCuboidAction.hpp \
+	SelectionAction/NotAllAtomsInsideSphereAction.hpp \
+	SelectionAction/NotAllAtomsOfMoleculeAction.hpp \
 	SelectionAction/NotAllMoleculesAction.hpp \
+	SelectionAction/NotAtomByElementAction.hpp \
 	SelectionAction/NotAtomByIdAction.hpp \
-	SelectionAction/NotMoleculeByIdAction.hpp
+	SelectionAction/NotMoleculeByFormulaAction.hpp \
+	SelectionAction/NotMoleculeByIdAction.hpp \
+	SelectionAction/NotMoleculeOfAtomAction.cpp
 
 TESSELATIONACTIONSOURCE = \
@@ -146,5 +182,4 @@
   WorldAction/InputAction.cpp \
   WorldAction/OutputAction.cpp \
-  WorldAction/RemoveSphereOfAtomsAction.cpp \
   WorldAction/RepeatBoxAction.cpp \
   WorldAction/ScaleBoxAction.cpp \
@@ -160,5 +195,4 @@
   WorldAction/InputAction.hpp \
   WorldAction/OutputAction.hpp \
-  WorldAction/RemoveSphereOfAtomsAction.hpp \
   WorldAction/RepeatBoxAction.hpp \
   WorldAction/ScaleBoxAction.hpp \
@@ -170,5 +204,7 @@
 lib_LTLIBRARIES = libMolecuilderActions-@MOLECUILDER_API_VERSION@.la
 libMolecuilderActions_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
-libMolecuilderActions_libs = ../Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la
+libMolecuilderActions_libs = \
+	../Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	../UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la
 nobase_libMolecuilderActions_include_HEADERS = ${ACTIONSHEADER}
 
@@ -209,2 +245,9 @@
 pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
 
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(ACTIONSSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Actions/MakroAction.cpp
===================================================================
--- src/Actions/MakroAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MakroAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MakroAction.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -44,4 +56,7 @@
 }
 
+void MakroAction::getParametersfromValueStorage()
+{};
+
 Dialog* MakroAction::fillDialog(Dialog *dialog) {
   return actions->fillAllDialogs(dialog);
Index: src/Actions/MakroAction.hpp
===================================================================
--- src/Actions/MakroAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MakroAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -32,4 +32,5 @@
   virtual Dialog *fillDialog(Dialog *dialog);
 private:
+  virtual void getParametersfromValueStorage();
   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
Index: src/Actions/ManipulateAtomsProcess.cpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ManipulateAtomsProcess.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ManipulateAtomsProcess.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -26,4 +38,7 @@
 ManipulateAtomsProcess::~ManipulateAtomsProcess()
 {}
+
+void ManipulateAtomsProcess::getParametersfromValueStorage()
+{};
 
 Dialog* ManipulateAtomsProcess::fillDialog(Dialog *dialog){
Index: src/Actions/ManipulateAtomsProcess.hpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ManipulateAtomsProcess.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -31,4 +31,5 @@
   virtual Dialog * fillDialog(Dialog*);
 private:
+  virtual void getParametersfromValueStorage();
   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
